
#ifndef PATTE_H
#define PATTE_H

#include "Atom.h"
//#include "Molecule.h"
#include "ConfigReader.h"

/**
 * la classe de patte gere une structure de patte base sur un system a 3 rotules avec une architecture
 * "epaule, genou, poignet" la patte n'a donc a stocker que 3 atoms qui serivont de rotules
 */
class Patte
{
private:
	// determine si la patte est une patte gauche ou pas (change l'algorithme de mouvement)
	bool isGauche;
	// la parite de la patte peut etre utile a connaitre.
	bool isPaire;
	// le tableau de 3 atoms
	API::Atom **atom;
	// l'indice de synchronization de mouvement courant
	int syncIndex;
protected:
public:
	Patte();// constructeur
	~Patte();// destructeur
	void setIsGauche(bool gauche);// pour changer la "gauchitude" de la patte
	void setIsPaire(bool paire);// change la parit de la patte
	void ajoutAtom(API::Atom * atom, int place);// ajoute l'atome a la place pass en parametre
	bool isMoving();// si un des atoms de la patte est en mouvement
	// attention cette methode ne test que les 3 atoms rotules ! si des atoms sont intercal ca ne et sont en mouvement ca
	// ne les test pas....
	void setSyncIndex(unsigned int index); // donne l'index de synchronization de la patte
	unsigned int getSyncIndex(); // retourn l'index de synchronization
	void initialise();// initialise la structure : descend le point de gravit
	void monte();// monte la patte
	void descend();// descend la patte
	void baisser();// a ne pas confondre avec descendre : baisser correspond a une descente de l'"epaule" de la patte en gros a 
	// descendre son centre de gravit
	void attrape();
	bool touchGround(int atom);
	void avance();// avance la patte
	void recule();// recule la patte
	void allonger();// allonge la patte a son maximum
	void descendreSimple();// descente simple de la patte en ne bougeant que l'epaule...
	void monteSimple();// descente simple de la patte en ne bougeant que l'epaule...
};
#endif
