#ifndef WALKER_H
#define WALKER_H

#include "Molecule.h"

class Walker : API::Molecule
{
 private:
  API::Atom *plan;
  int etape;
  int patteStraf;
  int moveType;
  unsigned int syncIndex;

 public:
  Walker();
  ~Walker();
  
  void initStruct();
  
  void walk();
  void walkOne();
  void walkTwo();
  void walkThree();
  void walkFour();
  void walkFive();
  
  void turnLeft();
  void goLeftOne();
  void goLeftTwo();
  void goLeftThree();
  void goLeftFour();
  void goLeftFive();
  
  void turnRight();
  void goRightOne();
  void goRightTwo();
  void goRightThree();
  void goRightFour();
  void goRightFive();
  
  void strafRight();
  void strafLeft();
  void straf1();
  void straf2();
  void straf3();
  
  void triang();
  void triang1();
  void triang2();
  void triang3();
  
  bool patteIsMoving(API::Atom * atome, int patteNumber);
  bool isMoving(API::Atom * atome);
  bool isStopped(API::Atom * atome, int nbrAtome);
  void checkSynchro();

};
#endif

