#include "pi2a14/pi2a14_crusty.h"

#include "ConfigReader.h"
#include "Atom.h"

//-------------------------------------------------------
Crusty::Crusty()
  {

  CR_DECLARE (KERNELSIDE);
  CR_DECLARE (SPHERESIDE);
  CR_DECLARE (LEGRADIUS);
  CR_DECLARE (LEGSIDE);

  CR_SETUP (Atom, KERNELSIDE, CR_DOUBLE);
  CR_SETUP (Atom, SPHERESIDE, CR_DOUBLE);
  CR_SETUP (Atom, LEGRADIUS, CR_DOUBLE);
  CR_SETUP (Atom, LEGSIDE, CR_DOUBLE);

 etape = 0;

  crusty = new API::Atom[5];

   for (int i = 0; i <  5 ; i++) //Cration des ranges d'atomes
   {
	    crusty[i].util->setCartesianPosition(new API::CartesianPosition(
	                                                                  DVAR(KERNELSIDE)*i+2*i*DVAR(LEGSIDE),
	                                                                  0,
	                                                                  0.75));
   }

  //Connection des atomes
  for (int i = 0; i < 4; i++)
	  {
		  printf("%d\n",i);
	    if (crusty[i].getLeg(0)->util->isConnectable(crusty[i+1].getLeg(1)))
	      crusty[i].getLeg(0)->setLink(crusty[i+1].getLeg(1));
	  }

  for (int i = 0;i < 5 ; i++)
  {
	  this->addAtom(&crusty[i]);
  }
  syncIndex = getNextSyncIndex();
  }
//-------------------------------------------------------
Crusty::~Crusty()
  {
  delete[] crusty;
  
  }
//-------------------------------------------------------
void Crusty::initStruct()
  {

  for(int i=0; i<5; i++)
  	{
	for (int j=0; j<6; j++)
	{
			crusty[i].getLeg(j)->getServoMotor(0)->setTargetPosition(125,KEEP,0,syncIndex);
			crusty[i].getLeg(j)->getServoMotor(1)->setTargetPosition(125,KEEP,0,syncIndex);
	}
	  crusty[i].getLeg(4)->getServoMotor(0)->setTargetPosition(100,KEEP,0,syncIndex);
	  crusty[i].getLeg(4)->getServoMotor(0)->setTargetPosition(125,KEEP,0,syncIndex);
	 
  	}
	etape = 0;
  
  }
//-------------------------------------------------------
void Crusty::changeBase1()
{
	printf("changeBase1\n");
	typeMove=1;
	crusty[0].getLeg(0)->getServoMotor(1)->setTargetPosition(175,KEEP,0,syncIndex);
	crusty[1].getLeg(1)->getServoMotor(1)->setTargetPosition(75,KEEP,0,syncIndex);

	crusty[1].getLeg(0)->getServoMotor(1)->setTargetPosition(175,KEEP,0,syncIndex);
	crusty[2].getLeg(1)->getServoMotor(1)->setTargetPosition(75,KEEP,0,syncIndex);

	crusty[2].getLeg(0)->getServoMotor(1)->setTargetPosition(175,KEEP,0,syncIndex);
	crusty[3].getLeg(1)->getServoMotor(1)->setTargetPosition(75,KEEP,0,syncIndex);
	
	crusty[3].getLeg(0)->getServoMotor(1)->setTargetPosition(175,KEEP,0,syncIndex);
	crusty[4].getLeg(1)->getServoMotor(1)->setTargetPosition(75,KEEP,0,syncIndex);
	crusty[4].getLeg(0)->getServoMotor(1)->setTargetPosition(175,KEEP,0,syncIndex);
	etape = 1;
}

void Crusty::changeBase2()
{
	printf("changeBase2\n");
	typeMove=2;
	crusty[0].getLeg(0)->getServoMotor(0)->setTargetPosition(175,KEEP,0,syncIndex);
	crusty[1].getLeg(1)->getServoMotor(0)->setTargetPosition(75,KEEP,0,syncIndex);
	
	crusty[1].getLeg(0)->getServoMotor(0)->setTargetPosition(175,KEEP,0,syncIndex);
	crusty[2].getLeg(1)->getServoMotor(0)->setTargetPosition(75,KEEP,0,syncIndex);
	
	crusty[2].getLeg(0)->getServoMotor(0)->setTargetPosition(175,KEEP,0,syncIndex);
	crusty[3].getLeg(1)->getServoMotor(0)->setTargetPosition(75,KEEP,0,syncIndex);
	
	crusty[3].getLeg(0)->getServoMotor(0)->setTargetPosition(175,KEEP,0,syncIndex);
	crusty[4].getLeg(1)->getServoMotor(0)->setTargetPosition(75,KEEP,0,syncIndex);
	crusty[4].getLeg(0)->getServoMotor(0)->setTargetPosition(175,KEEP,0,syncIndex);
	etape = 1;
}

void Crusty::walk()
{
	printf("walk\n");
	int * legsCouple;
	legsCouple = whatLegs(&crusty[0]);
	typeMove = 3;
	
	if ((legsCouple[0]==2)&&(legsCouple[1]==4))
	{
		//Appel pour (2,4)
		printf("pattes au sol : (2,4)\n");
		hautRight=0;
		hautLeft=250;
		avantLeft=250;
		avantRight=250;
		arriereLeft=0;
		arriereRight=0;
		walkStepOne(2,4);
	}
	if ((legsCouple[0]==2)&&(legsCouple[1]==5))
	{
		//Appel pour (5,2)
		printf("pattes au sol : (5,2)\n");
		hautRight=0;
		hautLeft=250;
		avantLeft=0;
		avantRight=250;
		arriereLeft=250;
		arriereRight=0;
		walkStepOne(5,2);
	}
	if ((legsCouple[0]==3)&&(legsCouple[1]==5))
	{
		//Appel pour (3,5)
		printf("pattes au sol : (3,5)\n");
		hautRight=0;
		hautLeft=250;
		avantLeft=0;
		avantRight=0;
		arriereLeft=250;
		arriereRight=250;
		walkStepOne(3,5);
	}
	if ((legsCouple[0]==3)&&(legsCouple[1]==4))
	{
		//Appel pour (4,3)
		printf("pattes au sol : (4,3)\n");
		hautRight=0;
		hautLeft=250;
		avantLeft=250;
		avantRight=0;
		arriereLeft=0;
		arriereRight=250;
		walkStepOne(4,3);
	}
}

void Crusty::walkStepOne(int legLeft, int legRight)
{
	printf("walkStepOne\n");
	left=legLeft;
	right=legRight;
	
	for (int i=0;i<5;i++)
	{
		if (i%2==0)
		{
			crusty[i].getLeg(left)->getServoMotor(0)->setTargetPosition(hautLeft,KEEP,0,syncIndex);
			crusty[i].getLeg(left)->getServoMotor(1)->setTargetPosition(avantLeft,KEEP,0,syncIndex);
			crusty[i].getLeg(right)->getServoMotor(1)->setTargetPosition(arriereRight,KEEP,0,syncIndex);
			crusty[i].getLeg(left)->getServoMotor(0)->setTargetPosition(125,KEEP,0,syncIndex);
		}
		else
		{
			crusty[i].getLeg(right)->getServoMotor(0)->setTargetPosition(hautRight,KEEP,0,syncIndex);
			crusty[i].getLeg(right)->getServoMotor(1)->setTargetPosition(avantRight,KEEP,0,syncIndex);
			crusty[i].getLeg(left)->getServoMotor(1)->setTargetPosition(arriereLeft,KEEP,0,syncIndex);
			crusty[i].getLeg(right)->getServoMotor(0)->setTargetPosition(125,KEEP,0,syncIndex);
		}
	}
	etape = 2;
}

void Crusty::walkStepTwo(int legLeft, int legRight)
{
	printf("walkStepTwo\n");
	left=legLeft;
	right=legRight;
	
	for (int i=0;i<5;i++)
	{
		if (i%2==0)
		{
			crusty[i].getLeg(right)->getServoMotor(0)->setTargetPosition(hautLeft,KEEP,0,syncIndex);
			crusty[i].getLeg(right)->getServoMotor(1)->setTargetPosition(avantLeft,KEEP,0,syncIndex);
			crusty[i].getLeg(left)->getServoMotor(1)->setTargetPosition(arriereRight,KEEP,0,syncIndex);
			crusty[i].getLeg(right)->getServoMotor(0)->setTargetPosition(125,KEEP,0,syncIndex);
		}
		else
		{
			//move(arriereLeft,125,avantRight
			
			crusty[i].getLeg(left)->getServoMotor(0)->setTargetPosition(hautRight,KEEP,0,syncIndex);
			crusty[i].getLeg(left)->getServoMotor(1)->setTargetPosition(avantRight,KEEP,0,syncIndex);
			crusty[i].getLeg(right)->getServoMotor(1)->setTargetPosition(arriereLeft,KEEP,0,syncIndex);
			crusty[i].getLeg(left)->getServoMotor(0)->setTargetPosition(125,KEEP,0,syncIndex);
		}
	}
	etape = 3;
}

void Crusty::turnRight()
{
	typeMove=4;
	crusty[2].getLeg(1)->getServoMotor(1)->setTargetPosition(25,KEEP,0,syncIndex);
		
	etape=1;
}

void Crusty::turnDownForUp()
{
	typeMove=4;
	crusty[3].getLeg(0)->getServoMotor(1)->setTargetPosition(10,KEEP,0,syncIndex);
	crusty[3].getLeg(0)->getServoMotor(0)->setTargetPosition(10,KEEP,0,syncIndex);
	crusty[3].getLeg(1)->getServoMotor(1)->setTargetPosition(240,KEEP,0,syncIndex);
	crusty[3].getLeg(1)->getServoMotor(0)->setTargetPosition(240,KEEP,0,syncIndex);
	etape=2;
}

void Crusty::turnReplace()
{
	typeMove=4;
	crusty[2].getLeg(1)->getServoMotor(1)->setTargetPosition(125,KEEP,0,syncIndex);
	crusty[2].getLeg(0)->getServoMotor(1)->setTargetPosition(225,KEEP,0,syncIndex);
	etape=3;
}

void Crusty::turnBack1()
{
	typeMove=4;
	crusty[3].getLeg(0)->getServoMotor(1)->setTargetPosition(100,KEEP,0,syncIndex);
	crusty[3].getLeg(0)->getServoMotor(0)->setTargetPosition(100,KEEP,0,syncIndex);
	crusty[3].getLeg(1)->getServoMotor(1)->setTargetPosition(160,KEEP,0,syncIndex);
	crusty[3].getLeg(1)->getServoMotor(0)->setTargetPosition(160,KEEP,0,syncIndex);
	etape=4;
}

void Crusty::turnBack2()
{
	typeMove=4;
	crusty[3].getLeg(1)->getServoMotor(1)->setTargetPosition(125,KEEP,0,syncIndex);
	crusty[3].getLeg(1)->getServoMotor(0)->setTargetPosition(125,KEEP,0,syncIndex);
	crusty[2].getLeg(0)->getServoMotor(1)->setTargetPosition(125,KEEP,0,syncIndex);
	crusty[3].getLeg(0)->getServoMotor(1)->setTargetPosition(125,KEEP,0,syncIndex);
	crusty[3].getLeg(0)->getServoMotor(0)->setTargetPosition(125,KEEP,0,syncIndex);
	etape=5;
}

void Crusty::turnReload()
{
	typeMove=4;
	crusty[3].getLeg(0)->getServoMotor(1)->setTargetPosition(125,KEEP,0,syncIndex);
	crusty[3].getLeg(0)->getServoMotor(0)->setTargetPosition(125,KEEP,0,syncIndex);
	etape=6;
}
//-------------------------------------------------------

void Crusty::move (int Xdepart, int Ydepart, int Xarrive, int Yarrive, API::Atom * atome, int patteNumber)
{
  int x = Xdepart;
  int y = Ydepart;
  int etapeNumber = 5;
  int deltaX =(int) (Xarrive - Xdepart)/etapeNumber;
  int deltaY =(int) (Yarrive - Ydepart)/etapeNumber;
  printf("deltaX %d, deltaY %d\n",deltaX,deltaY);
  for (int i = 0 ; i < etapeNumber-1;i++)
    {
      if(x != Xarrive)
	{
	  x+=deltaX;
	}
     if(y != Yarrive)
	{
	  y+=deltaY;
	}
      printf("x %d, y %d\n",x,y);
      atome->getLeg(patteNumber)->getServoMotor(0)->setTargetPosition(x,KEEP);
      atome->getLeg(patteNumber)->getServoMotor(1)->setTargetPosition(y,KEEP);

    }
  atome->getLeg(patteNumber)->getServoMotor(0)->setTargetPosition(Xarrive,KEEP);
  atome->getLeg(patteNumber)->getServoMotor(1)->setTargetPosition(Yarrive,KEEP);

}

bool Crusty::patteIsMoving(API::Atom * atome, int patteNumber)
{
	int marge = 112;
	return 	(((atome->getLeg(patteNumber)->getServoMotor(0)->getCurrentPosition() > atome->getLeg(patteNumber)->getServoMotor(0)->getTargetPosition()+marge)||
		(atome->getLeg(patteNumber)->getServoMotor(0)->getCurrentPosition() < atome->getLeg(patteNumber)->getServoMotor(0)->getTargetPosition()-marge))||
		((atome->getLeg(patteNumber)->getServoMotor(1)->getCurrentPosition() > atome->getLeg(patteNumber)->getServoMotor(1)->getTargetPosition()+marge)||
		(atome->getLeg(patteNumber)->getServoMotor(1)->getCurrentPosition() < atome->getLeg(patteNumber)->getServoMotor(1)->getTargetPosition()-marge)));
}

bool Crusty::isMoving(API::Atom * atome)
{
	
	return !isFinished(syncIndex);
}

bool Crusty::isStopped(API::Atom * atome, int nbrAtome)
{
	return isFinished(syncIndex);
}
/*
*whatLegs permet de rcuprer les numro des pattes
*se trouvant en contact avec le sol grce  la mthode
*API::Leg::Util::isOnGround().
*On les stock dans un tableau d'entiers accessibles par pointeurs.
*/
int * Crusty::whatLegs(API::Atom * atome)
{
	int j = 0;
	printf(" avant %d %d %d\n",temp[0],temp[1],temp[2]);
	for (int i=0; i<6; i++)
	{
		printf("patte teste : %d\n",i);
		if (atome->getLeg(i)->util->isOnGround())
		{
			temp[j]=i;
			printf("la patte %d est au sol\n",i);
			j++;
		}
	}
	printf(" apres %d %d %d\n",temp[0],temp[1],temp[2]);
	return temp;
}
//-------------------------------------------------------
/*
*Cette mthode est appel  chaque itration du simulateur et elle permet de
*coordonner tous les types de Mouvement possible et leurs diffrentes tapes.
*Chaque mouvement et identifi par un entier (typeMove),
*chaque tape par un numro (etape).
*Cette mthode ne s'xcute qu'une fois le mouvement prcdent fini, dfini par un *index de synchronisation (syncIndex), avec la condition 'isFinished(syncIndex)'.
*/
void Crusty::checkSynchro()
{
	if (isFinished(syncIndex))
	{
		if (etape != 0)
		{
			etape ++;
		}
		switch (typeMove)
		{
			case 1:
				switch (etape)
				{	
					case 1:
						printf("changeBase1\n");
						changeBase1();
						break;
						
					case 2: // fin
						printf("initStruct\n");
						initStruct();
						break;
						
				}
			case 2:
				switch (etape)
				{	
					case 1:
						printf("changeBase2\n");
						changeBase2();
						break;
						
					case 2: // fin
						printf("initStruct\n");
						initStruct();
						break;
						
				}
				
			case 3:
				switch (etape)
				{
					case 2:
						printf("walkStepOne\n");
						walkStepOne(left,right);
						break;
					
					case 3:
						printf("walkStepTwo\n");
						walkStepTwo(left,right);
						break;
					case 4:
						etape =1;
				}
				
				break;
			case 4:	
				switch (etape)
				{
					case 1:
						printf("turnAround\n");
						turnRight();
						break;
					
					case 2: 
						printf("up and down\n");
						turnDownForUp();
						break;
						
					case 3:
						printf("turn replace\n");
						turnReplace();
						break;
						
					case 4:
						printf("turn back1\n");
						turnBack1();
						break;
						
					case 5:
						printf("turn back2\n");
						turnBack2();
						break;
						
					case 6:
						printf("turn Reload\n");
						turnReload();
						break;
						
					case 7:
						etape = 0;
						break;
				}
			
			
				break;
			case 45: // fin
				
				break;
		}
	}
}
//-------------------------------------------------------
